(* Minisakk 1.0                                  *)
(* 1997, 2003 (c) Nmeth Lszl                  *)
(* Engedly: GNU GPL 2-es vltozat               *)
(* nemethl@gyorsposta.hu                         *)
(* http://www.math.u-szeged.hu/~bognarv/minisakk *)

unit Ablak;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls,
  QForms, QDialogs, QStdCtrls, QExtCtrls, QGrids,
  QMenus, QTypes, Sakk, Unit2, Think;

const
  Alap: TPoint = (X: -1; Y: -1);

  type
  TForm1 = class(TForm)
    Tabla: TDrawGrid;
    MainMenu1: TMainMenu;
    Aprogramrl1: TMenuItem;
    Label13: TLabel;
    Fjl1: TMenuItem;
    Kilp1: TMenuItem;
    jjtszma1: TMenuItem;
    Tisztsor2: TMenuItem;
    Vletlen1: TMenuItem;
    Alulvletlen1: TMenuItem;
    Aprogramrl2: TMenuItem;
    procedure TablaClick(Sender: TObject);
    procedure TablaDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Lep(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure TablaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Kilp1Click(Sender: TObject);
    procedure jjtszma1Click(Sender: TObject);
    procedure Szimmetrikus1Click(Sender: TObject);
    procedure Alul1Click(Sender: TObject);
    procedure Aprogramrl1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Inverz, Kurzor: TPoint;
  About: TAboutBox;
  oldheight, oldwidth: Integer;

implementation

{$R *.dfm}

procedure TForm1.TablaClick(Sender: TObject);
var
 X: TGridRect;
begin
X := Tabla.Selection;
{Label13.Caption := IntToStr(X.Left + 1) + ':' +
  IntToStr(X.Top + 1);}
end;

procedure TForm1.TablaDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
if (6 - Inverz.X  = Col) and (7 - Inverz.Y  = Row) then
  Tabla.Canvas.Brush.Color := clBlue
else
  if not Odd(Col + Row) then
    Tabla.Canvas.Brush.Color := clGray
   else Tabla.Canvas.Brush.Color := clSilver;
Tabla.Canvas.FillRect(Rect);
if Mind.t[7 - Row, 6 - Col] <= 10 then
  begin
   Tabla.Canvas.Brush.Color := clWhite;
   Tabla.Canvas.Pen.Color := clBlue
  end
else
  begin
   Tabla.Canvas.Brush.Color := clBlack;
   Tabla.Canvas.Pen.Color := clRed
  end;

case Mind.t[7 - Row, 6 - Col] of
1,11:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZKiraly,Ms.RKiraly);
    Tabla.Canvas.Polygon(Ms.RKiraly);
  end;
2,12:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZVezer,Ms.RVezer);
    Tabla.Canvas.Polygon(Ms.RVezer);
  end;
3,13:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZBastya,Ms.RBastya);
    Tabla.Canvas.Polygon(Ms.RBastya);
  end;
4,14:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZHuszar,Ms.RHuszar);
    Tabla.Canvas.Polygon(Ms.RHuszar);
  end;
5,15:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZFuto,Ms.RFuto);
    Tabla.Canvas.Polygon(Ms.RFuto);
  end;
6..10,16..20:
  begin
    RKonvert(Col*(Tabla.DefaultRowHeight+1),Row*(Tabla.DefaultRowHeight+1), Ms.ZGyalog,Ms.RGyalog);
    Tabla.Canvas.Polygon(Ms.RGyalog);
  end;
end;
if not Odd(Col + Row) then
    Tabla.Canvas.Brush.Color := clGray
   else Tabla.Canvas.Brush.Color := clWhitE;

end;

procedure TForm1.FormResize(Sender: TObject);
begin
  (* Egy holtponti tmretezs miatt kell als kszb *)
  if Tabla.Height < 100 then Height := 200;
  Tabla.DefaultRowHeight := (Tabla.Height - 10) div 6;
  Tabla.DefaultColWidth := Tabla.DefaultRowHeight;
  Tabla.Width := (Tabla.DefaultColWidth + 2) - 2;
  Width := (Tabla.DefaultRowHeight + 2) * 5 - 2;
  SakkZoom(Tabla.DefaultRowHeight);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Inverz := Alap;
  Kurzor := Alap;
end;

procedure TForm1.Lep(Sender: TObject);
var
  C, Cs: Byte;
  T, T2: TPoint;

  procedure Kirajzol(X, Y: Integer);
  begin
    X := 6 - X; Y := 7 - Y;
    TablaDrawCell(Sender, X, Y,
    Rect(X*(Tabla.DefaultColWidth+1), Y*(Tabla.DefaultRowHeight+1),
    (X + 1)*(Tabla.DefaultColWidth+1), (Y + 1)*(Tabla.DefaultRowHeight+1)), []);
  end;

    function MMax: Integer;
  var b, i, j, Max, n: Integer;
      e: Integer;
   begin
     n := 0;
     Max := -70;
     for b := 1 to 20 do
      for i := 2 to 7 do
       for j := 2 to 6 do
      begin
        e := Mind.M2[b, i, j];
        if e > Max then
            begin
              Max := e;
              n := 1;
            end
        else
          if e = Max then Inc(n);
     end;
     MMax := Max;
   end;

begin
if (Mind.t[Kurzor.Y, Kurzor.X] <> 0)
      and ((Mind.t[Kurzor.Y, Kurzor.X] div 11) * 10 = Mind.szin) then
 begin
 T := Inverz;
   if (Kurzor.X=Inverz.X) and (Kurzor.Y=Inverz.Y) then
     Inverz := Alap
   else
     Inverz := Kurzor;
 Kirajzol(T.X, T.Y);
 Kirajzol(Kurzor.X, Kurzor.Y);
 end else
 if ((inverz.X <> -1)) and Mind.lephet(inverz.Y,inverz.X,Kurzor.Y,Kurzor.X) then
   begin
     Mind.lep(inverz.Y,inverz.X,Kurzor.Y,Kurzor.X,0);
     T := Inverz;
     Inverz := Alap;
     Kirajzol(T.X, T.Y);
     Kirajzol(Kurzor.X, Kurzor.Y);

     if (Mind.t[Kurzor.Y, Kurzor.X] - Mind.szin > 5) and
             ((Kurzor.Y = 2) or (Kurzor.Y = 7)) then
     repeat
        Mind.Cserel_Tisztre(Kurzor.Y, Kurzor.X);
        Tabla.RePaint;
     until Application.MessageBox('J-e a tisztcsere?', 'Krds', [smbYES, smbNO]) = smbYES;
     Mind.szin := 10 - Mind.szin;
     Tabla.Repaint;
     Mind.Mit_lep_a_gep(Cs,C,T.Y,T.X);
     T2.X := Mind.b[C].P.X;
     T2.Y := Mind.b[C].P.Y;
     if (Mind.b[c].van = false) then Cs := C;
     Mind.lep(T2.Y, T2.X, T.Y, T.X, Cs);
     if Cs<>0 then Tabla.Repaint;
     if not Mind.nincs_sakkban_az_ellenfel then Label13.Caption := ' Sakk!'
       else Label13.Caption := '';
     Kirajzol(T2.X, T2.Y);
     Kirajzol(T.X, T.Y);
     Inverz := Alap;
     Mind.szin := 10 - Mind.szin;
     {Uj := False;}
   end;
end;

procedure TForm1.TablaKeyPress(Sender: TObject; var Key: Char);
var
 X: TGridRect;
begin
X := Tabla.Selection;
Kurzor.X := 6 - X.Left;
Kurzor.Y := 7 - X.Top;
if Key = #13 then
begin
  Lep(Sender);
end;
end;

procedure TForm1.TablaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 Z: TGridRect;
begin
Z := Tabla.Selection;
Kurzor.X := 6 - Z.Left;
Kurzor.Y := 7 - Z.Top;
  Lep(Sender);
end;

procedure TForm1.Kilp1Click(Sender: TObject);
begin
  Halt;
end;

procedure TForm1.jjtszma1Click(Sender: TObject);
begin
  Mind.Done;
  Mind.Init;
  Tabla.Repaint;
end;

procedure TForm1.Szimmetrikus1Click(Sender: TObject);
begin
  if Mind.uj_tabla then
  begin
  Mind.Urestabla;
  Mind.Felallit(Mind.Tisztsor(TRUE));
  Mind.Felallit(Parasztok);
  Tabla.Repaint;
  end
  else Label13.Caption := 'Csak j jtszma kezdsnl.';
end;

procedure TForm1.Alul1Click(Sender: TObject);
begin
  if Mind.uj_tabla then
  begin
  Mind.Felallit(Mind.Tisztsor(FALSE));
  Tabla.Repaint;
  end
  else Label13.Caption := 'Csak j jtszma kezdsnl.';
end;

procedure TForm1.Aprogramrl1Click(Sender: TObject);
begin
        About.ShowModal;
end;

begin
        About := TAboutBox.Create(Form1);
end.
