unit Sakk;

interface
uses Think, Types;
type

RKiralyTip = array[0..56] of TPoint;
RVezerTip = array[0..56] of TPoint;
RBastyaTip = array[0..34] of TPoint;
RHuszarTip = array[0..42] of TPoint;
RFutoTip = array[0..61] of TPoint;
RGyalogTip = array[0..36] of TPoint;

Sakktabla = record
  Mind: TThink;
  Kijelolt: TPoint;
  ZKiraly: RKiralyTip; RKiraly: RKiralyTip;
  ZVezer: RVezerTip; Rvezer: RvezerTip;
  ZBastya: RBastyaTip; RBastya: RBastyaTip;
  ZHuszar: RHuszarTip; RHuszar: RHuszarTip;
  ZFuto: RFutoTip; RFuto: RFutoTip;
  ZGyalog: RGyalogTip; RGyalog: RGyalogTip;
end;

procedure SakkZoom(A: Integer);
procedure RKonvert(X, Y: Integer; const Forras: array of TPoint; var Rajz: array of TPoint);

var Ms: Sakktabla;

implementation

const
 Lo: RHuszartip = (
(X: 33;Y: 113),(X: 106;Y: 113),(X: 106;Y: 104),(X: 105;Y: 99),(X: 100;Y: 96),
(X: 99;Y: 61),(X: 96;Y: 50),(X: 89;Y: 40),(X: 81;Y: 33),(X: 71;Y: 28),(X: 64;Y: 28),
(X: 60;Y: 24),(X: 58;Y: 22),(X: 55;Y: 17),(X: 52;Y: 14),(X: 50;Y: 14),(X: 48;Y: 20),
(X: 46;Y: 26),(X: 38;Y: 33),(X: 37;Y: 41),(X: 34;Y: 47),(X: 28;Y: 53),(X: 25;Y: 58),
(X: 22;Y: 67),(X: 23;Y: 70),(X: 24;Y: 74),(X: 27;Y: 76),(X: 34;Y: 76),(X: 35;Y: 70),
(X: 40;Y: 67),(X: 50;Y: 65),(X: 56;Y: 62),(X: 58;Y: 59),(X: 61;Y: 56),(X: 63;Y: 57),
(X: 64;Y: 67),(X: 59;Y: 72),(X: 52;Y: 76),(X: 41;Y: 81),(X: 38;Y: 86),(X: 37;Y: 96),
(X: 33;Y: 101),(X: 33;Y: 113));
 {vezr}
Vezer: RVezertip = (
(X: 27;Y: 113),
(X: 100;Y: 113),
(X: 101;Y: 103),
(X: 97;Y: 99),
(X: 92;Y: 95),
(X: 91;Y: 88),
(X: 98;Y: 66),
(X: 103;Y: 53),
(X: 110;Y: 49),
(X: 112;Y: 44),
(X: 112;Y: 37),
(X: 107;Y: 33),
(X: 100;Y: 33),
(X: 97;Y: 37),
(X: 95;Y: 40),
(X: 96;Y: 47),
(X: 93;Y: 52),
(X: 85;Y: 61),
(X: 79;Y: 36),
(X: 85;Y: 31), 
(X: 86;Y: 27),
(X: 86;Y: 23),
(X: 81;Y: 19),
(X: 76;Y: 17),
(X: 71;Y: 18),
(X: 68;Y: 23), 
(X: 68;Y: 31),
(X: 71;Y: 34),
(X: 68;Y: 45),
(X: 62;Y: 60),
(X: 58;Y: 48),
(X: 54;Y: 39), 
(X: 58;Y: 29),
(X: 58;Y: 24),
(X: 54;Y: 19),
(X: 46;Y: 17),
(X: 41;Y: 19),
(X: 39;Y: 24),
(X: 42;Y: 33),
(X: 44;Y: 35),
(X: 43;Y: 46),
(X: 40;Y: 61),
(X: 32;Y: 54), 
(X: 27;Y: 47),
(X: 30;Y: 41),
(X: 26;Y: 35),
(X: 17;Y: 34),
(X: 12;Y: 39),
(X: 12;Y: 46),
(X: 16;Y: 51),
(X: 20;Y: 52),
(X: 25;Y: 67),
(X: 31;Y: 85),
(X: 30;Y: 95),
(X: 27;Y: 97),
(X: 28;Y: 102),
(X: 27;Y: 113));

 {fut}

Futo: RFutotip = (
(X: 16;Y: 113), (X: 52;Y: 111), (X: 57;Y: 109), (X: 60;Y: 107), (X: 63;Y: 102),
(X: 66;Y: 106), (X: 69;Y: 109), (X: 72;Y: 112), (X: 110;Y: 113), (X: 112;Y: 106),
(X: 113;Y: 102), (X: 116;Y: 94), (X: 85;Y: 94), (X: 82;Y: 86), (X: 86;Y: 78),
(X: 89;Y: 73), (X: 89;Y: 67), (X: 89;Y: 54), (X: 87;Y: 49), (X: 86;Y: 43),
(X: 83;Y: 37), (X: 79;Y: 33), (X: 73;Y: 30), (X: 71;Y: 34), (X: 69;Y: 37),
(X: 67;Y: 43), (X: 65;Y: 49), (X: 65;Y: 56), (X: 58;Y: 56), (X: 57;Y: 51), 
(X: 60;Y: 43), (X: 63;Y: 36), (X: 65;Y: 31), (X: 69;Y: 25), (X: 69;Y: 21), 
(X: 70;Y: 16), (X: 68;Y: 13), (X: 64;Y: 11), (X: 61;Y: 10), (X: 56;Y: 12),
(X: 54;Y: 15), (X: 52;Y: 19), (X: 55;Y: 23), (X: 56;Y: 24), (X: 55;Y: 26),
(X: 51;Y: 30), (X: 47;Y: 33), (X: 43;Y: 36), (X: 38;Y: 44), (X: 35;Y: 49),
(X: 34;Y: 56), (X: 34;Y: 64), (X: 37;Y: 69), (X: 38;Y: 76), (X: 44;Y: 83),
(X: 43;Y: 88), (X: 40;Y: 94), (X: 11;Y: 93), (X: 13;Y: 97), (X: 13;Y: 102),
(X: 14;Y: 107), (X: 16;Y: 113));

 {gyalog}
Gyalog: RGyalogtip = (
(X: 33;Y: 112), (X: 95;Y: 112), (X: 94;Y: 102), (X: 92;Y: 97), (X: 90;Y: 94),
(X: 87;Y: 90), (X: 79;Y: 87), (X: 78;Y: 83), (X: 78;Y: 79), (X: 76;Y: 74),
(X: 74;Y: 72), (X: 72;Y: 69), (X: 68;Y: 66), (X: 69;Y: 62), (X: 75;Y: 58),
(X: 77;Y: 53), (X: 77;Y: 47), (X: 75;Y: 43), (X: 70;Y: 39), (X: 63;Y: 38),
(X: 58;Y: 38), (X: 56;Y: 42), (X: 54;Y: 48), (X: 54;Y: 52), (X: 56;Y: 57),
(X: 59;Y: 61), (X: 61;Y: 66), (X: 57;Y: 68), (X: 53;Y: 71), (X: 50;Y: 75),
(X: 49;Y: 77), (X: 49;Y: 83), (X: 43;Y: 88), (X: 39;Y: 90), (X: 37;Y: 95),
(X: 33;Y: 100), (X: 33;Y: 112));

{kiraly}
Kiraly: RKiralytip = (
(X: 26;Y: 113), (X: 99;Y: 113), (X: 99;Y: 103), (X: 98;Y: 100), (X: 97;Y: 97), 
(X: 93;Y: 96), (X: 93;Y: 79), (X: 91;Y: 76), (X: 93;Y: 72), (X: 95;Y: 69),
(X: 100;Y: 64), (X: 104;Y: 59), (X: 106;Y: 54), (X: 106;Y: 48), (X: 105;Y: 41), 
(X: 101;Y: 36), (X: 96;Y: 32), (X: 90;Y: 30), (X: 85;Y: 29), (X: 78;Y: 31), 
(X: 74;Y: 32), (X: 70;Y: 35), (X: 67;Y: 40), (X: 62;Y: 46), (X: 63;Y: 40), 
(X: 65;Y: 35), (X: 66;Y: 29), (X: 69;Y: 22), (X: 71;Y: 16), (X: 67;Y: 12), 
(X: 62;Y: 11), (X: 56;Y: 12), (X: 53;Y: 16), (X: 54;Y: 20), (X: 56;Y: 26), 
(X: 57;Y: 33), (X: 59;Y: 36), (X: 60;Y: 45), (X: 56;Y: 42), (X: 52;Y: 38), 
(X: 49;Y: 34), (X: 43;Y: 31), (X: 36;Y: 29), (X: 29;Y: 31), (X: 22;Y: 34),
(X: 19;Y: 41), (X: 17;Y: 49), (X: 18;Y: 56), (X: 21;Y: 62), (X: 25;Y: 67), 
(X: 29;Y: 72), (X: 31;Y: 77), (X: 29;Y: 80), (X: 29;Y: 95), (X: 27;Y: 97),
(X: 25;Y: 99), (X: 24;Y: 112));

{bstya}
Bastya: RBastyatip = (
(X: 28;Y: 112), (X: 100;Y: 112), (X: 100;Y: 102), (X: 100;Y: 99), (X: 97;Y: 97),
(X: 91;Y: 95), (X: 90;Y: 86), (X: 89;Y: 70), (X: 86;Y: 58), (X: 88;Y: 48),
(X: 92;Y: 43), (X: 93;Y: 26), (X: 86;Y: 26), (X: 82;Y: 36), (X: 73;Y: 37),
(X: 71;Y: 30), (X: 70;Y: 25), (X: 59;Y: 23), (X: 58;Y: 29), (X: 57;Y: 36),
(X: 48;Y: 37), (X: 45;Y: 31), (X: 44;Y: 26), (X: 36;Y: 26), (X: 36;Y: 33),
(X: 37;Y: 42), (X: 42;Y: 48), (X: 43;Y: 58), (X: 39;Y: 86), (X: 36;Y: 94),
(X: 34;Y: 96), (X: 33;Y: 96), (X: 29;Y: 98), (X: 28;Y: 101), (X: 28;Y: 112));

procedure RZoom(R: Real; const Forras: array of TPoint; var Rajz: array of TPoint);
var
  i: Integer;
begin
  for i := 0 to High(Forras) do
    begin
      Rajz[i].X := Round(Forras[i].X * R);
      Rajz[i].Y := Round(Forras[i].Y * R);
    end;
end;

procedure SakkZoom(A: Integer);
var
  R: Real;
begin
  R := A / 127;
  RZoom(R, Kiraly, Ms.ZKiraly);
  RZoom(R, Vezer, Ms.ZVezer);
  RZoom(R, Bastya, Ms.ZBastya);
  RZoom(R, Lo, Ms.ZHuszar);
  RZoom(R, Futo, Ms.ZFuto);
  RZoom(R, Gyalog, Ms.ZGyalog);
end;

procedure RKonvert(X, Y: Integer; const Forras: array of TPoint; var Rajz: array of TPoint);
var
  i: Integer;
begin
  for i := 0 to High(Forras) do
    begin
      Rajz[i].X := Forras[i].X + X;
      Rajz[i].Y := Forras[i].Y + Y;
    end;
end;

end.
