{$Q-}

unit Think;

interface

const Ertek: Array [0..9] of Byte = (0, 15, 9, 5, 5, 2, 2, 2, 2, 2);
      Alap = 'Re1Bd1Kc1Qb1Ha1:Re6Bd6Kc6Qb6Ha6';
      Parasztok = 'a2b2c2d2e2:a5b5c5d5e5';
(*      Alap = 'Kc3:Ke4';
      Parasztok = 'a2b2c2:c5d5e5'; *)
(*      Alap = 'Qb1Kc3:Ke4';
      Parasztok = 'a5b5c5d2e2:a2b2c2d5e5'; *)
{      Alap = 'Kc1:Kb3Re6';
      Parasztok = ':c3';}

      Tisztek: String[5] = 'KQRBH';
      SZINE: array [1..20] of Byte =
          (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10);

      kiir: boolean = false;

type  Tabla = array[0..9, 0..8] of Shortint;
      TPont = record Y, X: Byte; end;
      Egybab = record
                 van: Boolean;
                 ertek: ShortInt;
                 P: TPont;
               end;
      Babok = array[0..20] of Egybab;
      Minimax = array[1..20, 2..7, 2..6] of Integer;
{      Tomb = array [0..599] of ShortInt;}

  PThink = ^TThink;
  TThink = object
    t: tabla;
    b: babok;
    szin: Byte;
    melyseg, mely: Byte;
    uj_tabla: Boolean;
    matte, mattvissza: Boolean;
    Pont, Pontvissza, Ponte: Integer;
    MM, M2: Minimax;
    constructor Init;
    destructor Done;
    function kiralysakk:  Boolean;
    function vezersakk:  Boolean;
    function bastyasakk:  Boolean;
    function losakk:  Boolean;
    function futosakk:  Boolean;
    function gyalogsakk:  Boolean;
    function nincs_sakkban_az_ellenfel: Boolean;
    function Tisztsor(Szimmetrikus: Boolean): String;
    procedure felallit(st: String);
    procedure urestabla;
    procedure elemez;
    procedure Mit_lep_a_gep(var Csere, Mi: Byte; var Y, X: Integer);
    procedure lep(y1, x1, y2, x2: Byte; Csere: Byte);
    function lephet(y1, x1, y2, x2: Byte) : Boolean;
    procedure Cserel_Tisztre(y, x: Byte);
 private
    regt: Tabla;
    regb: Babok;
   regszin: Byte;
   procedure Elment;
   procedure Visszatolt;
  end;

var
  Mind: TThink;

implementation

uses Unit2;

constructor TThink.Init;
var I: Byte;
begin
  Randomize;
  for I := 1 to 20 do b[I].ertek := Ertek[(I - 1) mod 10];
  b[0].ertek := 0;
  melyseg := 0;
  szin := 0;
  urestabla;
  felallit(Alap);
  felallit(Parasztok);
  mely := 3;
  uj_tabla := TRUE;
end;

destructor TThink.Done;
begin
end;

function TThink.Tisztsor(Szimmetrikus: Boolean): String;
var  I, J: Byte;
     TS, E: String;

begin
  TS := Tisztek;
  E := Tisztek;
  for I := 5 downto 1 do
    begin
      J := Random(I) + 1;
      E[I] := TS[J];
      Delete(TS, J, 1);
    end;
  for I := 1 to 5 do TS := TS + E[I] + Char(Byte('a') - 1 + I) + '1';
  TS := TS + ':';
  if Szimmetrikus then for I := 1 to 5 do
     TS := TS + E[I] + Char(Byte('a') - 1 + I) + '6';
  Tisztsor := TS;
end;



procedure TThink.felallit(st: String);
var a, ba, pa, sz: Byte;
begin
sz := 0;
pa := 0;
a := 0;
while  (a < Length(st)) do
  begin
  Inc(a);
  ba := 0;
    case st[a] of
      ':': begin sz := 10; pa := 0; end;
      'K': ba := 1 + sz;
      'Q': ba := 2 + sz;
      'R': ba := 3 + sz;
      'H': ba := 4 + sz;
      'B': ba := 5 + sz;
    else
      ba := 6 + sz + pa;
      Inc(pa);
      Dec(a);
    end;
    if ba>0 then
      begin
        b[ba].van := true;
	b[ba].P.Y := byte(st[a+2])-byte('1') + 2;
	b[ba].P.X := byte(st[a+1])-byte('a') + 2;
        t[b[ba].P.Y, b[ba].P.X] := ba;
        Inc(a, 2);
      end;
  end;
end;


procedure TThink.urestabla;
var i, j: Byte;
begin
Fillchar(t, SizeOf(t), #100);
for i := 2 to 7 do
 for j := 2 to 6 do
  t[i, j] := 0;
for i := 1 to 20 do b[i].van := false;
end;

function TThink.kiralysakk: Boolean;
begin
kiralysakk := (sqr(b[1].P.Y-b[11].P.Y)+sqr(b[1].P.X-b[11].P.X)<3);
end;

function TThink.gyalogsakk: Boolean;
var a: Byte;
begin
a := b[11-szin].P.Y+(szin div 4)-1;
gyalogsakk := ((t[a, b[11-szin].P.X-1]-1)div 5 = (szin+5)div 5)
            or ((t[a, b[11-szin].P.X+1]-1)div 5 = (szin+5)div 5);
end;

function TThink.losakk: Boolean;
begin
losakk := b[szin+4].van and
(abs((b[szin+4].P.Y-b[11-szin].P.Y)*(b[szin+4].P.X-b[11-szin].P.X)) = 2);
end;

function TThink.vezersakk: Boolean;
var sd, od: Shortint;
    s, o: Byte;
begin
if not b[szin+2].van then vezersakk := false else
  begin
  s := b[11-szin].P.Y;
  o := b[11-szin].P.X;

  sd := b[szin+2].P.Y-s;
  od := b[szin+2].P.X-o;
  if (abs(sd) <> abs(od)) and (sd <> 0) and (od <> 0) then vezersakk := false else
    begin
    if sd <> 0 then sd := sd div abs(sd);
    if od <> 0 then od := od div abs(od);
    repeat
    Inc(s, sd);
    Inc(o, od);
    until t[s, o] <> 0;
    if t[s, o] = szin+2 then vezersakk := true else vezersakk := false;
    end;
  end;
end;

function TThink.bastyasakk: Boolean;
var sd, od:Shortint;
    s, o: Byte;
begin
if not b[szin+3].van then bastyasakk := false else
  begin
  s := b[11-szin].P.Y;
  o := b[11-szin].P.X;
  sd := b[szin+3].P.Y-s;
  od := b[szin+3].P.X-o;
  if (sd <> 0) and (od <> 0) then bastyasakk := false else
    begin
    if sd <> 0 then sd := sd div abs(sd);
    if od <> 0 then od := od div abs(od);
    repeat
    Inc(s, sd);
    Inc(o, od);
    until t[s, o] <> 0;
    if t[s, o] = szin+3 then bastyasakk := true else bastyasakk := false;
    end;
  end;
end;

function TThink.futosakk: Boolean;
var sd, od:Shortint;
    s, o: Byte;
begin
if not b[szin+5].van then futosakk := false else
  begin
  s := b[11-szin].P.Y;
  o := b[11-szin].P.X;
  sd := b[szin+5].P.Y-s;
  od := b[szin+5].P.X-o;
  if (abs(sd) <> abs(od)) then futosakk := false else
    begin
    if sd <> 0 then sd := sd div abs(sd);
    if od <> 0 then od := od div abs(od);
    repeat
    Inc(s, sd);
    Inc(o, od);
    until t[s, o] <> 0;
    if t[s, o] = szin + 5 then futosakk := true else futosakk := false;
    end;
  end;
end;

function TThink.nincs_sakkban_az_ellenfel: Boolean;
begin
nincs_sakkban_az_ellenfel := not (gyalogsakk or kiralysakk or losakk
                           or vezersakk or bastyasakk or futosakk);
end;

procedure TThink.elemez;
var i, mitut: Byte;
    regi, uj, cs: TPont;
    sd1, od1: ShortInt;
    matt: Boolean;
    ElozoPont: Integer;
    OsszPont: Integer;
    uji: Byte;

procedure lepes;

  function Min(X, Y: Integer): Integer;
  begin
    if X < Y then Min := X else Min := Y;
  end;

  function Max(X, Y: Integer): Integer;
  begin
    if X < Y then Max := Y else Max := X;
  end;

begin
if (t[uj.Y, uj.X] = 0) or ((t[uj.Y, uj.X] <> 100)
            and (SZINE[t[uj.Y, uj.X]] <> szin)) then
begin
 t[regi.Y, regi.X] := 0;
 mitut := t[uj.Y, uj.X];
 ElozoPont := Pont;
 if Odd(melyseg) then Dec(Pont, b[mitut].Ertek)
               else Inc(Pont, b[mitut].Ertek);
 b[mitut].van := false;
 t[uj.Y, uj.X] := i;

 b[i].P := uj;

 szin := 10 - szin;
 if nincs_sakkban_az_ellenfel then
   begin
      matte := false;
      Inc(melyseg);
      elemez;
      Dec(melyseg);
      if (melyseg = 0) then
      begin
        MM[i, uj.Y, uj.X] := PontVissza;
      end
       else begin if Odd(melyseg) then
        begin
          OsszPont := Min(OsszPont, Pontvissza);
          matt := matt and mattvissza;
        end
          else
        begin
          OsszPont := Max(OsszPont, Pontvissza);
          matt := matt or mattvissza;
        end;
       end;
{      matte := false;  xxx}
   end;
 Pont := ElozoPont;
 b[i].P := regi;
 t[regi.Y, regi.X] := i;
 b[mitut].van := true;
 t[uj.Y, uj.X] := mitut;
 szin := 10 - szin;
 end;
end;

procedure ciklus;
begin
  uj := regi;
  repeat
    Inc(uj.Y, sd1);
    Inc(uj.X, od1);
    lepes;
  until t[uj.Y, uj.X] <> 0;
end;

procedure procvezer;
begin
  sd1 := 0;  od1 := -1; ciklus;
  sd1 := 1; {od1 := -1;}ciklus;
 {sd1 := 1;} od1 := 0; ciklus;
 {sd1 := 1;} od1 := 1; ciklus;
  sd1 := 0; {od1 := 1;}ciklus;
  sd1 := -1; {od1 := 1;}ciklus;
 {sd1 := -1;} od1 := 0; ciklus;
 {sd1 := -1;} od1 := -1; ciklus;
end;

procedure procbastya;
begin
  sd1 := 0;od1 := -1;ciklus;
  {sd1 := 0;}od1 := 1;ciklus;
  sd1 := 1;od1 := 0;ciklus;
  sd1 := -1;{od1 := 0;}ciklus;
end;

procedure procfuto;
begin
sd1 := 1;od1 := -1;ciklus;
{sd1 := 1;}od1 := 1;ciklus;
sd1 := -1;{od1 := 1;}ciklus;
{sd1 := -1;}od1 := -1;ciklus;
end;

procedure proclo;
begin
uj.Y := regi.Y+1;
uj.X := regi.X-2;lepes;
Dec(uj.Y, 2);lepes;
Inc(uj.X, 4);lepes;
Inc(uj.Y, 2);lepes;
Dec(uj.X);Inc(uj.Y);lepes;
Dec(uj.X, 2);lepes;
Dec(uj.Y, 4);lepes;
Inc(uj.X, 2);lepes;
end;

procedure prockiraly;
begin
  uj.Y := regi.Y;
  uj.X := regi.X-1;
  lepes;
  Inc(uj.Y); lepes;
  Inc(uj.X); lepes;
  Inc(uj.X); lepes;
  Dec(uj.Y); lepes;
  Dec(uj.Y); lepes;
  Dec(uj.X); lepes;
  Dec(uj.X); lepes;
end;

procedure procgyalog;

procedure csere;
var
  cserelt: Byte;
begin
cserelt := i;
b[i].van := false;
uji := 2 + szin;
repeat
  if not b[uji].van then
  begin
    cs := b[uji].P;
    b[uji].van := true;
    b[uji].P.Y := uj.Y;
    b[uji].P.X := uj.X;
    i := uji;
    lepes;
    b[uji].P := cs;
    b[uji].van := false;
  end;
inc(uji);
until uji = 6+szin;
i := cserelt;
b[i].van := true;
t[regi.Y, regi.X] := i;
end;

begin
if szin = 0 then uj.Y := regi.Y + 1 else uj.Y := regi.Y - 1;
if (uj.Y = 2) or (uj.Y = 7) then
  begin
    uj.X := regi.X;if (t[uj.Y, uj.X] = 0) then begin csere;end;
    uj.X := uj.X-1;if (t[uj.Y, uj.X] <> 0) then begin csere;end;
    uj.X := uj.X+2;if (t[uj.Y, uj.X] <> 0) then begin csere;end;
  end else
  begin
    uj.X := regi.X;if (t[uj.Y, uj.X] = 0) then lepes;
    dec(uj.X);if (t[uj.Y, uj.X] <> 0) then lepes;
    inc(uj.X, 2);if (t[uj.Y, uj.X] <> 0) then lepes;
  end;
end;

begin
if (melyseg <= mely) then
begin
 if Odd(melyseg) then
   begin
     OsszPont := 50;
     matt := false;
     matte := false; { matte := false; feladvnymegoldsnl }
   end
 else
   begin
     OsszPont := -50;
     matt := true;
     matte := true;
   end;
  for i := 1+szin to 10+szin do
    begin
    if b[i].van then
      begin
        regi := b[i].P;
        mitut := 0;
        case i-szin of
          1: prockiraly;
          2: procvezer;
          3: procbastya;
          5: procfuto;
          4: proclo;
          6..10: procgyalog;
        end;
      end;
    end;

(*
if matte then
  begin
  szin := 10 - szin;
  if nincs_sakkban_az_ellenfel then {Patt, vagy matt?}
    begin
      matte := false;
      matt := false;
    end;
{      if Odd(melyseg) then Osszpont := Pont - 5 else OsszPont := Pont + 5;}
{    end
    else}
{      if Odd(melyseg) then Osszpont := Pont - 5 else OsszPont := Pont + 5;}
{  if Odd(melyseg) then Osszpont := Pont + 150 else OsszPont := Pont - 150;}
  szin := 10 - szin;
  end;
  *)

if matte and not Odd(melyseg) then
  begin
  szin := 10 - szin;
  if nincs_sakkban_az_ellenfel then {Patt, vagy matt?}
    begin
      Osszpont := 51;
      matte := false;
      matt := false;
    end;
  szin := 10 - szin;
  end;


if (melyseg = mely) then
  begin
   matt := matte;
   PontVissza := Pont;
   if Abs(PontVissza) = 50 then PontVissza := -PontVissza;
  end;

{if (melyseg = 1) then
   begin
   if matt then Dec(MM[i, uj.Y, uj.X], 20);
   end;}

(*if (melyseg = mely) {or matte} then matt := matte;*)

{if (melyseg = 1) and matt then begin kiir;readln;end;}

mattvissza := matt;

PontVissza := OsszPont;
{writeln('   ', osszpont);}

end else PontVissza := Pont;

end;

procedure TThink.Mit_lep_a_gep(var Csere, Mi: Byte; var Y, X: Integer);
var n: Integer;
    Max: Integer;
    vegjatek: Integer;

  function vegjatek_e: Integer;
  var bb, s: Integer;
  begin
     s := 0;
     for bb := 2 to 5 do
     begin
         if b[bb].van then s := s + 1;
     end;
     for bb := 12 to 15 do
     begin
         if b[bb].van then s := s + 1;
     end;
     if (not b[12].van) and (s < 5) then vegjatek_e := 1 else vegjatek_e := 0;
  end;

  function vegjatekkal(bb, mm, i, j: integer): Integer;
  begin
      if ((bb>15) and (bb<=20) and (vegjatek = 1))
       or (
         (bb=11) and (vegjatek = 1) and
        (sqrt(sqr(4-i)+sqr(4-j)) < sqrt(sqr(4-b[11].P.Y)+sqr(4-b[11].P.X)))
        ) then vegjatekkal := mm + 1 else vegjatekkal := mm;
  end;

  procedure MMegszamol;
  var b, i, j: Integer;
      e: Integer;
   begin
     n := 0;
     Max := -70;
     for b := 1 to 20 do
      for i := 2 to 7 do
       for j := 2 to 6 do
      begin
        e := vegjatekkal(b, MM[b, i, j], i, j);
        if e > Max then
            begin
              Max := e;
              n := 1;
            end
        else
          if e = Max then Inc(n);
     end;
   end;

  procedure JoLepesek(var Csere, Mi: Byte; var Y, X: Integer; Hanyadik: Integer);
  var b, i, j, n: Integer;
   begin
     n := 0;
     for b := 1 to 20 do
      for i := 2 to 7 do
       for j := 2 to 6 do
        if vegjatekkal(b,MM[b, i, j], i, j) = Max then
            begin
              if n = Hanyadik then
                begin
                  Csere := M2[b, i, j];
                  Mi := b;
                  Y := i;
                  X := j;
                  Exit;
                end;
              Inc(n);
            end;
   end;

begin
  FillChar(MM, SizeOf(MM), Byte(-70));
  FillChar(M2, SizeOf(MM), #0);
  Pont := 0;
  if kiir then Writeln('Melyseg:', Melyseg, 'Szin:', szin);
  Elemez;
  vegjatek := vegjatek_e;
  MMegszamol;
  if (Max = -70) or (n = 600) then begin Csere := 0; Mi := 0; X := 1; Y:= 1; end
     else JoLepesek(Csere, Mi, Y, X, Random(n));
end;

procedure TThink.lep(y1, x1, y2, x2: Byte; Csere: Byte);
var i, j: Byte;
begin
 if (Csere <> 0) then
 begin (* fekete gyalog cserje, BUG thet rossz gyaloggal is,
 ha kett is lehetsges! *)
     i := 0;
     for j := 16 to 20 do
        if b[j].van and (b[j].P.Y = 3) and (
         ((abs(b[j].P.X - x2) = 0) and (t[y2, x2] = 0)) or
         ((abs(b[j].P.X - x2) = 1) and (t[y2, x2] > 0) and (t[y2, x2] <= 5)))
         then i := j;
     if i <> 0 then
     begin
     b[i].van := false;
     t[b[i].P.Y, b[i].P.X] := 0;
     b[i].P.Y := 0;
     b[i].P.X := 0;

     if t[y2,x2] <> 0 then
     begin
       b[t[y2,x2]].van := false;
       t[y2,x2] := 0;
     end;

     b[Csere].van := true;
     t[y2, x2] := Csere;
     b[Csere].P.Y := y2;
     b[Csere].P.X := x2;
     uj_tabla := false;
     exit;
     end;
 end;
 i := t[y1, x1];
 t[y1, x1] := 0;
 b[t[y2, x2]].van := false;
 t[y2, x2] := i;
 b[i].P.Y := y2;
 b[i].P.X := x2;
 uj_tabla := FALSE;
end;

function TThink.lephet(y1, x1, y2, x2: Byte) : Boolean;

  function bab_ad_e_sakkot (i: Byte): Boolean;
   begin
    lep(b[11-szin].P.Y, b[11-szin].P.X, y2, x2, 0);
    case i-szin of
     1: bab_ad_e_sakkot := kiralysakk;
     2: bab_ad_e_sakkot := vezersakk;
     3: bab_ad_e_sakkot := bastyasakk;
     4: bab_ad_e_sakkot := losakk;
     5: bab_ad_e_sakkot := futosakk;
    end;
    Visszatolt;
   end;

  function gyalog_lep (i: Byte): Boolean;
  var a: Byte;
   begin
    gyalog_lep := false;
    a := b[i].P.Y + (1 - (szin div 4));
    if (a = y2) and (
        ((b[i].P.X = x2) and (t[a, x2] = 0)) or
        ((b[i].P.X - 1 = x2) and (t[a, x2] <> 0)) or
        ((b[i].P.X + 1 = x2) and (t[a, x2] <> 0)))
     then gyalog_lep := true;
   end;

 begin
  Elment;
  lephet := false;
  if not nincs_sakkban_az_ellenfel then
      begin end
      {MessageBox('Sakkban az ellenfl!', nil, mfError + mfOkButton)}
      else
        begin
        if ((t[y1, x1] - szin < 6) and bab_ad_e_sakkot(t[y1, x1])) or
           ((t[y1, x1] - szin > 5) and gyalog_lep(t[y1, x1]))
           then
             begin
             Visszatolt;
             lep(y1, x1, y2, x2, 0);
             szin := 10 - szin;
             if not nincs_sakkban_az_ellenfel then
               begin end
               {MessageBox(' >> Sakk! << ', nil, mfError + mfOkButton)}
                 else lephet := true;
             end
               else begin end {MessageBox('Ilyen lps nincs a sakkban!', nil, mfError + mfOkButton)}
        end;
  Visszatolt;
 end;

procedure TThink.Cserel_Tisztre(y, x: Byte);
var regii, uji, i: Byte;
begin
  regii := t[y, x];
  if t[y, x] - szin >= 5 then uji := 2 + szin
    else uji := regii;
  i := 1;
  while (i < 6) and b[uji].van do
   begin
    inc(uji);
    if uji = 6 + szin then uji := 2;
    inc(i);
   end;
  if not b[uji].van then
   begin
    b[regii].van := false;
    b[uji].van := true;
    b[uji].P.Y := y;
    b[uji].P.X := x;
    t[y, x] := uji;
   end;
end;

procedure TThink.Elment;
begin
regszin := szin;
regt := t;
regb := b;
end;

procedure TThink.Visszatolt;
begin
szin := regszin;
t := regt;
b := regb;
end;

begin
  Mind.Init;
end.

